'''
Created on 21/07/2009

@author: LUIS.RANGEL
'''

import os
import ftplib
from ftplib import FTP
from utilidades.stack import Stack
from modelo.archivoFTP import *

class GestionaSitio(object):
    def __init__(self, sitio, usuario, contrasegna):
        self.ftp = FTP(sitio)
        self.ftp.login(usuario, contrasegna)
        self.stack = Stack()
        self.listaDirectorios = []
        pass
    
    def obtenArchivos(self, directorio = None, idSitio = -1):
        def gestionaArchivo(texto):
            esDir = texto[0] == 'd'
            archSig = self.regresaNArchivo(texto, directorio, idSitio)
            
            if esDir:
                self.stack.push(archSig)
        
        comando = 'LIST'
        if directorio != None and len(directorio) > 0:
            comando = comando + ' ' + directorio
        try:
            self.ftp.retrlines(comando, gestionaArchivo)
        except Exception, e:
            print e
        if self.stack.is_empty() == 0:
            self.obtenArchivos(self.stack.pop(), idSitio)
    
    def regresaNArchivo(self, texto, directorio, idSitio):
        nEl = ArchivoFTP()
        nEl.parse(texto)
        if directorio != None:
            nEl.nArchivo = directorio + "/" + nEl.nArchivo
        else:
            nEl.nArchivo = "/" + nEl.nArchivo
        
        nEl.setIdSitio(idSitio)
        self.listaDirectorios.append(nEl)
        return nEl.nArchivo
    
    def obtenListaDirectorios(self):
        return self.listaDirectorios
    
    def cerrar(self):
        self.ftp.close()