'''
Created on 21/07/2009

@author: LUIS.RANGEL
'''

from modelo.archivoFTP import *
from modelo.atributosSitio import *
from gestionaSitio import *
from utilidades.Coneccion import *
from ui.uiComparaArchivos import *

class Sitio(object):
    def __init__(self, atributoSitio):
        self.conn = Coneccion()
        self.atributos = atributoSitio
        
        self.archivosBD = []
        self.archivosFTP = []
        
        if self.atributos.idSitio < 1 and len(self.atributos.nombre) > 0 and len(self.atributos.URL) > 0:
            #Guardar informacion en BD
            self.conn.executeUpdate('''INSERT OR REPLACE INTO sitio(nombre, URL, usuario, contrasegna) VALUES(?, ?, ?, ?)''', (self.atributos.nombre, self.atributos.URL, self.atributos.usuario, self.atributos.contrasegna))
            renglon = self.conn.executeSimpleQuery('''SELECT * FROM sitio WHERE nombre = '%s' ''' % self.atributos.nombre)
            self.atributos.idSitio = int(renglon["id"]) 
            self.atributos.nombre = renglon["nombre"]
            self.atributos.URL = renglon["URL"]
            self.atributos.usuario = renglon["usuario"]
            self.atributos.contrasegna = renglon["contrasegna"]
            pass
        
        self.archivosBD = Sitio.obtenArchivos(self.atributos.idSitio)
    
    @staticmethod
    def actualizaSitio(atributos):
        conn = Coneccion()
        if int(atributos.idSitio) > 0:
            conn.executeUpdate('''UPDATE sitio SET nombre = ?, URL = ?, usuario = ?, contrasegna = ? WHERE id = ? ''', (atributos.nombre, atributos.URL, atributos.usuario, atributos.contrasegna, atributos.idSitio))
        else:
            conn.executeUpdate('''INSERT OR IGNORE INTO sitio(nombre, URL, usuario, contrasegna) VALUES(?, ?, ?, ?)''', (atributos.nombre, atributos.URL, atributos.usuario, atributos.contrasegna))
            renglon = conn.executeSimpleQuery('''SELECT * FROM sitio WHERE nombre = '%s' ''' % atributos.nombre)
            atributos.idSitio = int(renglon["id"]) 
            atributos.nombre = renglon["nombre"]
            atributos.URL = renglon["URL"]
            atributos.usuario = renglon["usuario"]
            atributos.contrasegna = renglon["contrasegna"]
    
    @staticmethod
    def pruebaSitio(atributosSitio):
        salida = True
        try:
            gestionaSitio = GestionaSitio(unicode(atributosSitio.URL), unicode(atributosSitio.usuario), unicode(atributosSitio.contrasegna))
            gestionaSitio.cerrar()
        except ftplib.Error, e:
            salida = False
        except Exception, e:
            salida = False
        return salida
    
    def cargaInfo(self):
        gestionaSitio = GestionaSitio(self.atributos.URL, self.atributos.usuario, self.atributos.contrasegna)
        gestionaSitio.obtenArchivos(idSitio = self.atributos.idSitio)
        gestionaSitio.cerrar()
        self.archivosFTP = gestionaSitio.obtenListaDirectorios()
        
        self.archivosBD = Sitio.obtenArchivos(self.atributos.idSitio)
        pass
    
    def sincroniza(self):
        print "Sincronizando", self.atributos.idSitio
        (BD_noFTP, FTP_noBD, BD_FTP) = self.compara()
        if len(BD_noFTP) > 0:
            Sitio.eliminaArchivos(BD_noFTP)
        
        if len(self.archivosFTP) > 0:
            Sitio.guardaArchivos(self.archivosFTP)
        
        self.cargaInfo()
        pass
    
    def compara(self):
        BD_noFTP = [n for n in self.archivosBD if n not in self.archivosFTP] # eliminados
        FTP_noBD = [n for n in self.archivosFTP if n not in self.archivosBD] # agregados
        BD_FTP = [n for n in self.archivosBD if n not in BD_noFTP]
        return BD_noFTP, FTP_noBD, BD_FTP
    
    def comparaArchivosUI(self, hss):
        ca = UIComparaArchivos(self)
        ca.resize(500,500)
        if ca.exec_():
            hss.start()
    
    def regresaAtributos(self):
        return self.atributos
    
    @staticmethod
    def guardaArchivos(archivos):
        conn = Coneccion()
        vComandos = []
        vParametros = []
        for archivo in archivos:
            vComandos.append('''INSERT OR REPLACE INTO archivos(id_sitio, nArchivo, fecha, tamagno, grupo, usuario, permisos) values(?, ?, ?, ?, ?, ?, ?)''')
            vParametros.append((archivo.idSitio, archivo.nArchivo, archivo.fecha, archivo.tamagno, archivo.grupo, archivo.usuario, archivo.permisos))
        
        conn.executeMultipleUpdates(vComandos, vParametros)
    
    @staticmethod
    def eliminaArchivos(archivos):
        conn = Coneccion()
        vComandos = []
        vParametros = []
        for archivo in archivos:
            vComandos.append('''DELETE FROM archivos WHERE id_sitio = ? AND nArchivo = ?''')
            vParametros.append((archivo.idSitio, archivo.nArchivo))
        
        conn.executeMultipleUpdates(vComandos, vParametros)
    
    @staticmethod
    def eliminaArchivosSitio(idSitio):
        salida = False
        conn = Coneccion()
        if idSitio > 0:
            conn.executeUpdate("DELETE FROM archivos WHERE id_sitio = %s" % idSitio)
            salida = True
        return salida
            
    
    @staticmethod
    def obtenArchivos(idSitio = None):
        salida = []
        conn = Coneccion()
        comando = "SELECT * FROM archivos"
        if idSitio != None and idSitio > 0:
            comando = comando + " WHERE id_sitio = '%s' " % str(idSitio)
        
        renglones = conn.executeQuery(comando)
        for renglon in renglones:
            archFtp = ArchivoFTP()
            archFtp.idSitio = renglon["id_sitio"]
            archFtp.nArchivo = renglon["nArchivo"]
            archFtp.fecha = renglon["fecha"]
            archFtp.tamagno = renglon["tamagno"]
            archFtp.grupo = renglon["grupo"]
            archFtp.usuario = renglon["usuario"]
            archFtp.permisos = renglon["permisos"]
            salida.append(archFtp)
        
        return salida
