'''
Created on 27/07/2009

@author: LUIS.RANGEL
'''

import sys
from enum import Enum
from PyQt4.QtGui import *
from PyQt4.QtCore import *
from resources_rc import *
from functools import partial

class TableWidgetStatus(QTableWidgetItem):
    def __init__(self, tipo = 0):
        QTableWidgetItem.__init__(self)
        self.__tipo = tipo
        
        if tipo == 1:
            self.setIcon(QIcon(QPixmap(":/remove")))
            
        if tipo == 2:
            self.setIcon(QIcon(QPixmap(":/add")))

    def getTipo(self):
        return self.__tipo
    
    def setTipo(self, value):
        self.__tipo = value
    
    tipo = property(getTipo, setTipo, None, None)
    
    def __ge__(self, otro):
        return self.tipo >= otro.tipo
    
    def __lt__(self, otro):
        return self.tipo <= otro.tipo

class CargaInfo(QThread):
    def __init__(self, sitio, tabla, cabeceras, parent = None):
        QThread.__init__(self, parent)
        self.tabla = tabla
        self.sitio = sitio
        self.cabeceras = cabeceras
    
    def run(self):
        cSitio = 0        
        (BD_noFTP, FTP_noBD, BD_FTP) = self.sitio.compara()
        
        if len(BD_noFTP) + len(FTP_noBD) > 0:
            self.emit(SIGNAL("NoArch"))
        
        for archivo in BD_FTP:
            self.tabla.insertRow(cSitio)
            self.agregaRegistro(unicode(archivo.nArchivo), cSitio)
            cSitio = cSitio + 1
        
        for archivo in BD_noFTP:
            self.tabla.insertRow(cSitio)
            self.agregaRegistro(unicode(archivo.nArchivo), cSitio, 1)
            cSitio = cSitio + 1
        
        for archivo in FTP_noBD:
            self.tabla.insertRow(cSitio)
            self.agregaRegistro(unicode(archivo.nArchivo), cSitio, 2)
            cSitio = cSitio + 1
    
    def agregaRegistro(self, texto, cSitio, status = 0):
        iNombre = QTableWidgetItem(texto)
        iStatus = TableWidgetStatus(status)
        
        iNombre.setFlags(Qt.ItemIsSelectable | Qt.ItemIsEnabled)
        iStatus.setFlags(Qt.ItemIsSelectable | Qt.ItemIsEnabled)
        
        self.tabla.setItem(cSitio, self.cabeceras.Nombre.index, iNombre)
        self.tabla.setItem(cSitio, self.cabeceras.Status.index, iStatus)
        self.tabla.resizeColumnsToContents()
        pass

class UIComparaArchivos(QDialog):
    
    cabeceras = Enum("Status", "Nombre")
    
    def __init__(self, sitio, parent = None):
        QDialog.__init__(self, parent)
        
        self.tabla = QTableWidget(self)
        self.bSincronizar = QPushButton("Sincronizar")
        self.bCerrar = QPushButton("Cerrar")
        self.bSincronizar.setEnabled(False)
        self.lCargando = QLabel("Cargando...")
        
        vbox = QVBoxLayout()
        hbox = QHBoxLayout()
        vbox.addWidget(self.tabla)
        hbox.addWidget(self.bSincronizar)
        hbox.addWidget(self.bCerrar)
        vbox.addLayout(hbox)
        vbox.addWidget(self.lCargando)
        self.setLayout(vbox)
        
        self.connect(self.bSincronizar, SIGNAL("clicked()"), self.accept)
        self.connect(self.bCerrar, SIGNAL("clicked()"), self.reject)
        
        self.tabla.setSortingEnabled(True)
        
        self.cargaInfo(sitio)
    
    def cargaInfo(self, sitio):
        self.tabla.setColumnCount(len(self.cabeceras))
        self.tabla.setHorizontalHeaderLabels([str(x) for x in self.cabeceras])
        self.cInfo = CargaInfo(sitio, self.tabla, self.cabeceras, self)
        self.connect(self.cInfo, SIGNAL("NoArch"), partial(self.bSincronizar.setEnabled, False))
        self.connect(self.cInfo, SIGNAL("started ()"), self.lCargando.show)
        self.connect(self.cInfo, SIGNAL("finished()"), self.tabla.resizeColumnsToContents)
        self.connect(self.cInfo, SIGNAL("finished()"), self.lCargando.hide)
        self.cInfo.start()
