'''
Created on 22/07/2009

@author: LUIS.RANGEL
'''
import os, sys
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from modelo.atributosSitio import *
from modelo.sitio import Coneccion
from modelo.sitio import Sitio

class UISitio(QDialog):
    def __init__(self, aSitio = None, parent = None):
        QDialog.__init__(self, parent)
        
        self.setWindowTitle("Gestion Sitio")
        self.nSitio = QLineEdit()
        self.URL = QLineEdit()
        self.nUsuario = QLineEdit()
        self.contrasegna = QLineEdit()
        self.bGuardar = QPushButton("Guardar")
        self.bCancelar = QPushButton("Cancelar")
        self.contrasegna.setEchoMode(QLineEdit.PasswordEchoOnEdit)
        
        
        self.cargaInfo(aSitio)
        
        grid = QGridLayout()
        grid.addWidget(QLabel("Nombre:"), 0, 0)
        grid.addWidget(self.nSitio, 0, 1)
        grid.addWidget(QLabel("URL:"), 1, 0)
        grid.addWidget(self.URL, 1, 1)
        grid.addWidget(QLabel("Usuario:"), 2, 0)
        grid.addWidget(self.nUsuario, 2, 1)
        grid.addWidget(QLabel("Password:"), 3, 0)
        grid.addWidget(self.contrasegna, 3, 1)
        
        hlayout = QHBoxLayout()
        hlayout.addWidget(self.bGuardar)
        hlayout.addWidget(self.bCancelar)
        
        vlayout = QVBoxLayout()
        vlayout.addLayout(grid)
        vlayout.addLayout(hlayout)
        
        self.setLayout(vlayout)
        
        self.connect(self.bGuardar, SIGNAL("clicked()"), self.accept)
        self.connect(self.bCancelar, SIGNAL("clicked()"), self.reject)
    
    def cargaInfo(self, aSitio):
        self.aSitio = aSitio
        if aSitio == None:
            self.aSitio = AtributosSitio()
        else:
            self.nSitio.setText(aSitio.nombre)
            self.URL.setText(aSitio.URL)
            self.nUsuario.setText(aSitio.usuario)
            self.contrasegna.setText(aSitio.contrasegna)
    
    def obtenInfo(self):
        sitioNuevo = AtributosSitio()
        sitioNuevo.idSitio = self.aSitio.idSitio
        sitioNuevo.nombre = self.nSitio.text()
        sitioNuevo.URL = self.URL.text()
        sitioNuevo.usuario = self.nUsuario.text()
        sitioNuevo.contrasegna = self.contrasegna.text()
        return sitioNuevo
    
    def accept(self):
        sitio = self.obtenInfo()
        if Sitio.pruebaSitio(sitio):
            QDialog.accept(self)
        else:
            msgBox = QMessageBox();
            msgBox.setText("Datos Incorrectos, favor de comprobarles");
            msgBox.exec_();