'''
Created on 23/07/2009

@author: LUIS.RANGEL
'''
import sqlite3, os

class Coneccion(object):
    @staticmethod
    def getConexion():
        return sqlite3.connect('sitios.db')
    
    @staticmethod
    def generaEstructura():
        conn = Coneccion.getConexion()
        c = conn.cursor()
        c.execute('''CREATE TABLE IF NOT EXISTS sitio(id INTEGER PRIMARY KEY, nombre UNIQUE, URL NOT NULL, usuario, contrasegna)''')
        c.execute('''CREATE TABLE IF NOT EXISTS archivos(id INTEGER PRIMARY KEY, id_sitio NOT NULL, nArchivo NOT NULL, fecha DEFAULT '', tamagno DEFAULT '', grupo DEFAULT '', usuario DEFAULT '', permisos DEFAULT '', UNIQUE(id_sitio, nArchivo))''')
        conn.close()
    
    def executeQuery(self, query, parametros = None):
        conn = Coneccion.getConexion()
        conn.row_factory = sqlite3.Row
        c = conn.cursor()
        if parametros == None:
            c.execute(query)
        else:
            c.execute(query, parametros)
        
        renglon = c.fetchall()
        conn.close()
        return renglon
    
    def executeSimpleQuery(self, query, parametros = None):
        conn = Coneccion.getConexion()
        conn.row_factory = sqlite3.Row
        c = conn.cursor()
        if parametros == None:
            c.execute(query)
        else:
            c.execute(query, parametros)
        
        renglon = c.fetchone()
        conn.close()
        return renglon
    
    def executeUpdate(self, comando, parametros = None):
        conn = Coneccion.getConexion()
        c = conn.cursor()
        if parametros != None:
            c.execute(comando, parametros)
        else:
            c.execute(comando)
            
        conn.commit()
        conn.close()
    
    def executeMultipleUpdates(self, comandos, parametros = None):
        conn = Coneccion.getConexion()
        c = conn.cursor()
        for i in range(len(comandos)):
            comando = comandos[i]
            parametro = parametros[i]
            
            if parametro != None:
                c.execute(comando, parametro)
            else:
                c.execute(comando)
            
        conn.commit()
        conn.close()